const pocket = require('pocket');
pocket.configure(config).build();

// instantiate with config
const Pocket = require('pocket');
const pocket = new Pocket(config);

class Pocket {
  constructor (config = {}) {

  }

  newResource (name, schema) {
    this.registerResource(new Resource(name, schema, this))
  }

  registerResource(name, model) {
    this.resources[]
  }
}

const User = pocket.registerResource('user', schema);



// Other.js

import Pocket;

let Post = Pocket.Model({
  name: "string"
})
.before("save", () => {

});

Post.find();

// Pocket.registerResource("post", Post);

const fileStoreAdapters = require('./adapters/filestore'); // { FileStoreFS, FileStoreS3, FileStoreGridFS }
const jsonStoreAdapters = require('./adapters/jsonstore'); // { JsonStoreNEDB, JsonStoreMongo }

class Pocket extends EventEmitter {
  constructor(config) {
    this.fileStore = new fileStoreAdapters[config.fileStoreAdapter.name](this, config.fileStoreAdapter);
    this.jsonStore = new jsonStoreAdapters[config.jsonStoreAdapter.name](this, config.jsonStoreAdapter);

    this.initialised = Q.deferred();

    Promise.all([
      this.fileStore.ready(),
      this.jsonStore.ready()
    ]).then(() => {
      this.initialised.resolve()
    });

    this._resources = {};
  }
  resource(name, schema) {
    if (schema) this._resources[name] = new Resource(pocket, config, schema); 
    return this._resources[name];
  }
  use(plugin, options) {}
  middleware () {}
  get config () {}
  get filestore () {} // sync
  get jsonstore () {} // sync
}

class JsonAdapter {
  constructor(pocket, config) {}
  find (query, options) {}
  create (object) {}
  update (query, object) {}
  ready () {}
}

class FileAdapter {
  constructor(pocket, config) {}
  upload (file) {}
  download (id) {}
  remove (id) {}
  ready () {}
}

class Resource {
  constructor(pocket, config, schema) {
    this.schema = schema;
    const { hooks } = schema.toParams();
    const { statics, relationships } = schema.toParams();
    Object.entries(statics).forEach(([key, fn]) => this[key] = fn);
    this.fs = pocket.fileStore;
    this.db = pocket.jsonStore;
  }
  get (id) {}
  async find (query, options) {
    await this.schema.runHooks('before', 'find', { query, options });
    
    const records = await this.db.find(query, { 
      limit: options.limit, 
      skip: options.skip, 
      sort: options.sort, 
      project: options.project
    });
    
    await this.schema.runHooks('after', 'find', { records, query, options });

    return records;
  }
  findOne (query, options) {}
  create (object, options) {}
  update (query, object, options) {}
  updateOne (id, object, options) {}
  remove (query, options) {}
  removeOne (id, options) {}
  attach (id, name, file) {}
  readAttachment(attId) {}
  removeAttachment (id, attId) {}
  validate (object) {
    return this.schema.validate(object);
  }
}

class Schema {
  constructor(fields) {}
  before (name, fn) {}
  after (name, fn) {}
  validate (object) {}
  runHooks(name, context) {}
  toParams () {}
}

// user.js

const pocket = require('./pocket');

const schema = new Schema({
  name: 'string'
});

schema.before('find', ({ query, options: { context: { user } } }) => {
  switch (user.role) {
    case 'admin':
      break;
    case 'trainer':
      query.trainerId = user.id;
      break;
    case 'client':
      query.id = user.id;
  }
});

schema.before('save', ({ object, options }) => {
  object.createdAt = new Date().toISOString();
});

schema.after('save', function ({ object, options }) {
  if (object.createdAt === object.updatedAt) {
    this.emit('created', object, options);
  } else {
    this.emit('updated', object, options);
  }
  this.emit('collection-updated');
});

schema.after('remove', async ({ object }) => {
  const Company = pocket.resource('company');
  await Company.remove(user.companyId);
});

schema.statics.login = async function login (username, password) {
  const user = await this.findOne({ username, password });
  return user;
}

schema.virtual.fullname = function (options) {
  return `${this.firstname} ${this.lastname}`;
}

schema.computed.company = async function (options) {
  const Company = pocket.resource('company');
  const company = await Company.findOne({ id: this.companyId });
  return company;
}

schema.hasOne('company') 

const usersWithCompanies = await User.find({}, { populateRelationships: [{
  name: 'company',
  populateRelationships: ['users']
}] });

// srcField: 'companyId',
//   targetField: 'company',
//   resource: 'company',
//   resourceField: 'id',

exports = module.exports = pocket.resource('user', schema);

// pocket.js

const pocket = new Pocket(require('./config.json'));

pocket.use(Timestamps);

exports = module.export = pocket;

// index.js
const pocket = require('./pocket');

app.use('/cms', pocket.middleware());


const remote = talker();
const rpc = remote.rpc();

rpc.call('user.login', username, password);

// const User = pocket.resource('user', user);

// Pocket
//   Adapter
//     Resource
//       Schema
